# -*- coding: utf-8 -*-
from setuphelpers import *
import json

conf_json = """
{
    "proxy": {
        "ProxyMethod": 2,
        "Port": "8080",
        "autoConfigUrl": "http://server.domain.lan/proxy.pac"
    },
    "isAllowNTLMCredentialsForAllDomainsEnabled": false
}
"""


conf_json = """
{
    "proxy": {
        "UseSystem": true,
        "Host": "192.168.0.1",
        "UserName": "john_doe",
        "Password": "fido",
        "Port": "8080"
    },
    "miniCallerView": false,
    "isScreenSharingToolbarEnabled": false,
    "isSpellCheckEnabled": true,
    "initialOpenAtLogin": false
}
"""
conf_json = """{"initialOpenAtLogin": false}"""
if conf_json:
    if type(conf_json) == dict:
        conf_data = json.loads(conf_json)
    else:
        conf_data = conf_json
conf_dir = makepath(programfiles32, "Lifesize Installer")
conf_path = makepath(conf_dir, "settings.json")


def install():
    bin_name = glob.glob("Lifesize Setup *.msi")[0]

    # Uninstalling older major versions of the software
    for to_uninstall in installed_softwares(name="^Lifesize Installer$"):
        if Version(to_uninstall["version"]) < Version(control.get_software_version()) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])

    # Installing the software
    install_msi_if_needed(
        bin_name,
        timeout=600,
        remove_old_version=True,
    )

    # Applying configuration dict
    if conf_json:
        print("Applying configuration in: %s" % conf_path)
        json_write_file(conf_path, conf_data)


def session_setup():
    user_conf_dir = makepath(application_data, "Lifesize", "electron-settings")
    user_conf_path = makepath(user_conf_dir, "settings.json")

    # Applying configuration dict
    if conf_json:
        print("Applying configuration in: %s" % conf_path)
        mkdirs(user_conf_dir)
        json_write_file(user_conf_path, conf_data)
